#!/bin/bash

docker build --quiet --tag docker-youki .

run-test () {
    RUNTIME="$1"
    shift
    docker run --rm -it \
        --cap-add=ALL \
        "$@" \
        --security-opt=seccomp=unconfined \
        -v /sys/fs/cgroup:/sys/fs/cgroup \
        docker-youki \
        $RUNTIME create -b tutorial tutorial_container \
        > /dev/null
    
    STATUS="$?"
    if [ "$STATUS" == "0" ]; then
        echo "Runtime $RUNTIME works with --cap-add=ALL $@"
    else
        echo "Runtime $RUNTIME fails (status $STATUS) with --cap-add=ALL $@"
    fi
}

run-test youki
run-test youki --cap-drop=CHECKPOINT_RESTORE
run-test runc --cap-drop=CHECKPOINT_RESTORE
